using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Media;
using System.Windows.Shapes;
using System.Windows.Input;


namespace ControlsExamples
{
    /// <summary>
    /// Interaction logic for Example5.xaml
    /// </summary>

    public partial class Example5 : Window
    {
        private bool unsavedChanges = false;
        public Example5()
        {
            InitializeComponent();

            // Note: the New command is bound by default to the Ctrl-N
            // shortcut, so we don't need to add any buttons or menus
            // to invoke the command. We just register a handler.
            CommandBinding cmdBindingNew = new CommandBinding(ApplicationCommands.New);
            cmdBindingNew.Executed += NewCommandHandler;
            CommandBindings.Add(cmdBindingNew);

            inputBox.TextChanged += delegate { unsavedChanges = true; };
        }

        private void NewCommandHandler(object sender, ExecutedRoutedEventArgs e)
        {
            if (unsavedChanges)
            {
                MessageBoxResult result = MessageBox.Show(this,
                    "Save changes to existing document?", "New",
                    MessageBoxButton.YesNoCancel);

                if (result == MessageBoxResult.Cancel)
                {
                    return;
                }
                if (result == MessageBoxResult.Yes)
                {
                    SaveChanges();
                }
            }

            // Reset text box contents
            inputBox.Clear();
            unsavedChanges = false;
        }

        private void SaveChanges()
        {
            // Not a real app, obviously...
            unsavedChanges = false;
        }
    }
}