using System;
using System.Windows;
using System.Windows.Media;
using System.Windows.Shapes;
using System.Windows.Documents;

namespace ControlsExamples
{
    /// <summary>
    /// Interaction logic for Example19.xaml
    /// </summary>

    public partial class Example19 : Window
    {
        public Example19()
        {
            InitializeComponent();
        }
        private void AddRectangleClick(object sender, RoutedEventArgs e)
        {
            Rectangle rect = new Rectangle();
            SetShapeParams(rect);
            inputBox.Selection.Start.InsertTextElement(new BlockUIContainer(rect));
        }

        private void AddEllipseClick(object sender, RoutedEventArgs e)
        {
            Ellipse ellipse = new Ellipse();
            SetShapeParams(ellipse);
            inputBox.Selection.Start.InsertTextElement(new BlockUIContainer(ellipse));
        }

        private void SetShapeParams(Shape s)
        {
            s.Width = double.Parse(widthBox.Text);
            s.Height = double.Parse(heightBox.Text);
            BrushConverter b = new BrushConverter();
            if (fillBox.Text.Length > 0)
            {
                s.Fill = (Brush)b.ConvertFromString(fillBox.Text);
            }
            if (strokeBox.Text.Length > 0)
            {
                s.Stroke = (Brush)b.ConvertFromString(strokeBox.Text);
            }
        }

    }
}