using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Media;
using System.Windows.Shapes;
using System.Windows.Input;


namespace ControlsExamples
{
    /// <summary>
    /// Interaction logic for Example7.xaml
    /// </summary>

    public partial class Example7 : Window
    {
        public Example7()
        {
            InitializeComponent();

            codeInvoke.Click += new RoutedEventHandler(codeInvoke_Click);
            codeInvokeSpecific.Click += new RoutedEventHandler(codeInvokeSpecific_Click);

            CommandBinding cmdBindingFoo = new CommandBinding(MyLib.Commands.MyCommands.Foo);
            cmdBindingFoo.Executed += new ExecutedRoutedEventHandler(cmdBindingFoo_Execute);
            CommandBindings.Add(cmdBindingFoo);

        }

        void cmdBindingFoo_Execute(object sender, ExecutedRoutedEventArgs e)
        {
            MessageBox.Show("Executed", "Foo");
        }

        void codeInvokeSpecific_Click(object sender, RoutedEventArgs e)
        {
            MyLib.Commands.MyCommands.Foo.Execute(this, codeInvokeSpecific);
        }

        void codeInvoke_Click(object sender, RoutedEventArgs e)
        {
            MyLib.Commands.MyCommands.Foo.Execute(this, codeInvokeSpecific);
        }

    }
}