using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Media;
using System.Windows.Shapes;
using System.Reflection;
using System.IO;
using System.Windows.Media.Imaging;
using System.Collections.Generic;
using System.Collections;
using System.Resources;
using System.Diagnostics;


namespace ResourcesExamples
{
    /// <summary>
    /// Interaction logic for Example25.xaml
    /// </summary>

    public partial class Example25 : Window
    {
        public Example25()
        {
            InitializeComponent();

            Assembly asm = Assembly.GetExecutingAssembly();
            Stream s = asm.GetManifestResourceStream(@"ResourcesExamples.Images.Moggie.jpg");
            BitmapImage bmp = new BitmapImage();
            bmp.BeginInit();
            bmp.StreamSource = s;
            bmp.EndInit();
            imgElem.Source = bmp;


            foreach (string resource in GetResourceNames(asm, Dispatcher.Thread.CurrentUICulture))
            {
                // Note, this won't print out Moggie.jpg, because that's embedded as
                // an assembly manifest resource. GetResourceNames retrieves only
                // those resources nested inside the AppName.g.resources assembly
                // manifest stream, so it won't see anything living in some other
                // stream.
                Debug.WriteLine(resource);
            }
        }

        static List<string> GetResourceNames(Assembly asm,
                       System.Globalization.CultureInfo culture)
        {

            string resourceName = asm.GetName().Name + ".g";
            ResourceManager rm = new ResourceManager(resourceName, asm);
            ResourceSet resourceSet = rm.GetResourceSet(culture, true, true);
            List<string> resources = new List<string>();
            foreach (DictionaryEntry resource in resourceSet)
            {
                resources.Add((string)resource.Key);
            }
            rm.ReleaseAllResources();
            return resources;

        }
    }
}