using System;
using System.Windows;
using System.Windows.Controls;
using System.Collections;

namespace ResourcesExamples
{
    public partial class Example20 : Window
    {

        public Example20()
        {
            InitializeComponent();

            EnsureSkins();

            radioSkins.SelectionChanged += SkinChanged;
        }

        static ResourceDictionary greenSkin;
        static ResourceDictionary blueSkin;
        static bool resourcesLoaded = false;

        private static void EnsureSkins()
        {
            if (!resourcesLoaded)
            {
                greenSkin = MergeAppResourcesIntoSkin(new GreenSkin());
                blueSkin = MergeAppResourcesIntoSkin(new BlueSkin());

                resourcesLoaded = true;
            }
        }

        static ResourceDictionary MergeAppResourcesIntoSkin(ResourceDictionary skinResources)
        {
            ResourceDictionary nonSkinAppResources = Application.Current.Resources;

            foreach (DictionaryEntry de in nonSkinAppResources)
            {
                skinResources.Add(de.Key, de.Value);
            }
            return skinResources;
        }

        private void SkinChanged(object o, SelectionChangedEventArgs e)
        {
            switch (radioSkins.SelectedIndex)
            {
                case 0:
                    Application.Current.Resources = greenSkin;
                    break;
                case 1:
                    Application.Current.Resources = blueSkin;
                    break;
            }
        }
    }
}
