using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Media;
using System.Windows.Shapes;


namespace GraphicsExamples
{
    /// <summary>
    /// Interaction logic for Figures2325.xaml
    /// </summary>

    public partial class Figures2325 : Window
    {
        public Figures2325()
        {
            InitializeComponent();
        }

        private void ArcSizeChanged(object sender, RoutedEventArgs e)
        {
            Path[] paths = { path1, path2, path3, path4 };
            foreach (Path path in paths)
            {
                if (path != null)
                {
                    PathGeometry geom = (PathGeometry)path.Data;
                    ArcSegment arc = (ArcSegment)geom.Figures[0].Segments[0];
                    arc.Size = new Size(xSizeSlider.Value, ySizeSlider.Value);
                }
            }
        }

        private void RotationChanged(object sender, RoutedEventArgs e)
        {
            Path[] paths = { path1, path2, path3, path4 };
            foreach (Path path in paths)
            {
                PathGeometry geom = (PathGeometry)path.Data;
                ArcSegment arc = (ArcSegment)geom.Figures[0].Segments[0];
                arc.RotationAngle = xRotSlider.Value;
                
                // In what looks like a beta 1 bug, setting the XRotation doesn't
                // cause a repaint. To work around this, we set the size here.
                // (Even though we're setting the size to what should be its
                // current value, this seems to be enough to trigger a repaint.)
                arc.Size = new Size(xSizeSlider.Value, ySizeSlider.Value);
            }
        }

    }
}