﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace AlmostScaleable
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            DoubleBuffered = true;

            DrawingScale = 1;
        }

        private float m_scale;

        public float DrawingScale
        {
            get { return m_scale; }
            set
            {
                if (m_scale != value)
                {
                    m_scale = value;
                    Invalidate();

                    lblScaleValue.Text = m_scale.ToString();
                }
            }
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            if (DrawingScale > 0.00001f)
            {
                Graphics g = e.Graphics;
                GraphicsState state = g.Save();
                g.SmoothingMode = SmoothingMode.AntiAlias;

                g.TranslateTransform(0, 30);
                g.ScaleTransform(DrawingScale, DrawingScale);

                PointF[] points = new PointF[6];
                for (int i = 0; i < points.Length; ++i)
                {
                    double theta = (((float) i) / 2.5) * 2.0 * Math.PI;
                    double r = 50;
                    double x = Math.Cos(theta) * r;
                    double y = Math.Sin(theta) * r;
                    points[i] = new PointF((float) (x + 50.0),
                        (float) (y + 50.0));
                }
                g.DrawPolygon(Pens.Blue, points);
                g.DrawString("Hello, world!", Font,
                    Brushes.Green, 0, 0);
                g.Restore(state);
            }
            base.OnPaint(e);
        }

        private void trkScale_Scroll(object sender, EventArgs e)
        {
            float value = trkScale.Value;
            value /= 10f;
            DrawingScale = value;
        }
    }
}