using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Media;
using System.Windows.Shapes;
using System.Windows.Threading;
using System.Diagnostics;


namespace AnimationExamples
{
    /// <summary>
    /// Interaction logic for Example11.xaml
    /// </summary>

    public partial class Example11 : Window
    {
        public Example11()
        {
            InitializeComponent();

            // Force clock to start when window created. (Otherwise the
            // animation is pegged to when the first window in the app
            // opens in Beta 1!  So by the time the user opens this window,
            // the animation is probably already over...)
            FindStoryboardClock(Storyboards[0]).ClockController.Begin();

            t = new DispatcherTimer();
            t.Tick += new EventHandler(OnTimerTick);
            t.Interval = TimeSpan.FromSeconds(0.5);
            t.Start();
            start = DateTime.Now;
        }
        private DispatcherTimer t;
        private DateTime start;

        void OnTimerTick(object sender, EventArgs e)
        {
            TimeSpan elapsedTime = DateTime.Now - start;
            Debug.WriteLine(elapsedTime.ToString() + ": " +
                myEllipse.Width);
        }
    }
}