using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Controls;
using System.Windows;

namespace CustomControlsExamples
{
    public class ControlWithPlaceholder : Control
    {
        public static DependencyProperty IsMyPlaceholderProperty;

        static ControlWithPlaceholder()
        {

            PropertyMetadata isMyPlaceholderMetadata = new PropertyMetadata(false,
                new PropertyChangedCallback(OnIsMyPlaceholderChanged));

            IsMyPlaceholderProperty = DependencyProperty.RegisterAttached(
                "IsMyPlaceholder", typeof(bool),
                typeof(ControlWithPlaceholder), isMyPlaceholderMetadata);
        }

        public static bool GetIsMyPlaceholder(DependencyObject target)
        {
            return (bool)target.GetValue(IsMyPlaceholderProperty);
        }
        public static void SetIsMyPlaceholder(DependencyObject target, bool value)
        {
            target.SetValue(IsMyPlaceholderProperty, value);
        }
        private static void OnIsMyPlaceholderChanged(object target, DependencyPropertyChangedEventArgs args)
        {
            FrameworkElement targetElement = target as FrameworkElement;
            if (targetElement != null && GetIsMyPlaceholder(targetElement))
            {
                ControlWithPlaceholder containingControl =
                    targetElement.TemplatedParent as ControlWithPlaceholder;
                if (containingControl != null)
                {
                    containingControl.placeholder = targetElement;
                }
            }
        }
        private FrameworkElement placeholder;
    }
}
