using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;

namespace CustomControlsExamples
{
    public class MyCustomControl6 : ContentControl
    {

        public static RoutedEvent BarEvent;
        public static RoutedEvent PreviewBarEvent;

        static MyCustomControl6()
        {
            BarEvent = EventManager.RegisterRoutedEvent("Bar",
                RoutingStrategy.Bubble, typeof(EventHandler), typeof(MyCustomControl));
            PreviewBarEvent = EventManager.RegisterRoutedEvent("PreviewBar",
                RoutingStrategy.Tunnel, typeof(RoutedEventHandler),
                typeof(MyCustomControl));
        }

        public event RoutedEventHandler Bar
        {
            add { AddHandler(BarEvent, value); }
            remove { RemoveHandler(BarEvent, value); }
        }
        public event RoutedEventHandler PreviewBar
        {
            add { AddHandler(PreviewBarEvent, value); }
            remove { RemoveHandler(PreviewBarEvent, value); }
        }

        protected virtual void OnBar()
        {
            RoutedEventArgs args = new RoutedEventArgs();
            args.RoutedEvent = PreviewBarEvent;
            RaiseEvent(args);
            if (!args.Handled)
            {
                args = new RoutedEventArgs();
                args.RoutedEvent = BarEvent;
                RaiseEvent(args);
            }
        }
    }
}
