using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Diagnostics;

namespace CustomControlsExamples
{
    public class ControlWithAttachedProp : Control
    {

        public static DependencyProperty IsBarProperty;

        static ControlWithAttachedProp()
        {
            PropertyChangedCallback isBarInvalidated =
                new PropertyChangedCallback(OnIsBarChanged);
            PropertyMetadata isbarMetadata = new PropertyMetadata(false, isBarInvalidated);
            IsBarProperty = DependencyProperty.RegisterAttached("IsBar", typeof(bool),
                typeof(ControlWithAttachedProp), isbarMetadata);
        }

        static void OnIsBarChanged(object target, DependencyPropertyChangedEventArgs e)
        {
            Debug.WriteLine("IsBar just changed: " + GetIsBar((DependencyObject) target));
        }

        public static bool GetIsBar(DependencyObject target)
        {
            return (bool)target.GetValue(IsBarProperty);
        }

        public static void SetIsBar(DependencyObject target, bool value)
        {
            target.SetValue(IsBarProperty, value);
        }

    }
}
