using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Diagnostics;

namespace CustomControlsExamples
{
    public class ControlWithAttachedProp : Control
    {

        public static DependencyProperty IsBarProperty;

        static ControlWithAttachedProp()
        {
            PropertyInvalidatedCallback isBarInvalidated =
                new PropertyInvalidatedCallback(OnIsBarChanged);
            PropertyMetadata isbarMetadata = new PropertyMetadata(false, isBarInvalidated);
            IsBarProperty = DependencyProperty.RegisterAttached("IsBar", typeof(bool),
                typeof(ControlWithAttachedProp), isbarMetadata);
        }

        static void OnIsBarChanged(DependencyObject target)
        {
            Debug.WriteLine("IsBar just changed: " + GetIsBar(target));
        }

        public static bool GetIsBar(DependencyObject target)
        {
            return (bool)target.GetValueBase(IsBarProperty);
        }

        public static void SetIsBar(DependencyObject target, bool value)
        {
            target.SetValueBase(IsBarProperty, value);
        }

    }
}
